package dialogtool;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.text.*;
import tools.*;
/**
 * 12-05-03 <br>
 *
 * pemet d afficher un message<br>
 * Copyright (C) 2003 Gros Pierre-Emmanuel<br>
 * 
 * gros@limsi.fr<br>
 * 
 * 
 *
 * This program is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU General Public License<br>
 * as published by the Free Software Foundation; either version 2<br>
 * of the License, or any later version.<br>
 *
 * This program is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the<br>
 * GNU General Public License for more details.<br>
 *
 * You should have received a copy of the GNU General Public License<br>
 * along with this program; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.<br>
 *
 * permet d'afficher un message
 *  @author Gros Pierre Emmanuel
 *         <a href="mailto:gros@limsi.fr">gros@limsi.fr</a>
 * @version 9.0
 *
 * 
 */
public class WarningPane extends JScrollPane
{ /**
   * affiche le document 
   */
  protected JTextPane m_monitor;
  /**
   * le context d'affichage
   */
  protected StyleContext m_context; 
  /**
   * le document 
   */
  protected DefaultStyledDocument m_doc;
  /**
   * la gestion RTF du document 
   */
  protected StyledEditorKit m_kit;
  /**
   * le debut de la zone d'edition 
   */


/**
 * @param label le petit message
 * 
 */
public WarningPane()
{
super(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
	      JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
m_monitor = new JTextPane();	      
m_kit = new StyledEditorKit();
m_monitor.setEditorKit(m_kit);
m_context = new StyleContext();
m_doc = new DefaultStyledDocument(m_context);
m_monitor.setDocument(m_doc);
m_monitor.setDoubleBuffered(true);
setViewportView(m_monitor);


}
public WarningPane(String label)
{
this();
setText(label);
}
/**
 * @param label le petit message
 * 
 */
 public void setText(String label)
{
try
{
DefaultStyledDocument d=m_doc;
try {d.remove (0,d.getLength());} catch (Exception ff) {LogFile.println("setDocument"+ff);};
d.insertString(0,label,new SimpleAttributeSet() );
}
catch (Exception b) {LogFile.println("setDocumentb"+b);}
}
}

