package logique;
import java.io.*;
import java.util.*;
import javax.swing.text.*;
import tools.*;
/**
 * La classe ListeTag represente une liste de Tag au sein <br>
 * du document
 */
public class ListeTag implements Serializable
{
private Vector _listeTag;
private Tag _tagActif;
public Tag getActif()
{
return _tagActif;
}
public void setActif(Tag actif)
{
_tagActif=actif;
}
/**
 * renvoie la liste des tag sous forme de vecteur
 */
public Vector getListeTag(){return _listeTag;}

private void writeObject(java.io.ObjectOutputStream out)
     throws IOException
     {
     	out.writeObject(_listeTag);
     	 LogFile.println(_listeTag);
     	
     }
private void readObject(java.io.ObjectInputStream in)
     throws IOException, ClassNotFoundException
     {
     	_listeTag = (Vector) in.readObject();
	
     	}
 
 
/**
 * constructeur de la classe
 */
 
public ListeTag(){_listeTag=new Vector(10,10);}
/**
 * Ajoute un tag a la liste
 */
public void add(Tag t) {
	 LogFile.println("ListeTag::add(Tag) :"+size());
	
	_listeTag.add(t);}
/**
 * renvoie le ieme tag de la liste
 */
public Tag get(int i) {return (Tag)_listeTag.get(i);}
public boolean recouvre(int debut ,int fin)
{
Tag tmp=null;
boolean result=false;
for(int i=0;i<_listeTag.size();i++)
{
tmp=get(i);
boolean b=tmp.recouvre(debut,fin);
/***************TODO checker logique****************/

// LogFile.println("tag i:"+i+" valeur :"+b);
result=result||b;
}
// LogFile.println("recouvre"+result);
return result;
}
public Vector getSuperieurTag(Tag t)
{
Vector result=null;
Tag tmp=null;
for (int i=0;i<_listeTag.size();i++)
{
tmp=get(i);
if (tmp!=t && t.Inside(tmp.getDebut(),tmp.getFin()))
{
if (result==null) result=new Vector(10,10);
result.add(tmp);
}
}
return result;
}
public Tag search(int debut ,int fin)
{
Tag result=null;

for(int i=0;i<_listeTag.size();i++)
{
if (get(i).IsMe(debut,fin)) 
{
if (result==null) result=get(i);
else
{
if (get(i).getTaille()<=result.getTaille())
{
result=get(i);
}
}
}
}
return result;
}
/**
 * renvoie le tag , dont les bornes encadre au plus proche l'entier passer
 */
public Tag search(int caret)
{
Tag result=null;

for(int i=0;i<_listeTag.size();i++)
{
if (get(i).IsMe(caret)) 
{
if (result==null) result=get(i);
else
{
if (get(i).getTaille()<=result.getTaille())
{
result=get(i);
}
}
}
}
return result;
}
/**
 * prend en compte le fait que dans le document , on a rajouter du text<br>
 * offset est l'endroit dans le document ou on a rajouter le texte<br>
 * taille est la taille du texte rajouter
 */
public void AddText(int offset,int taille,int nb_ligne)
{
// LogFile.println("Addtext :"+size()+"this"+this.toString());
if (_tagActif==null || (offset!=_tagActif.getDebut() &&  offset!=_tagActif.getFin())) 
{
for (int i=0;i<size();i++) {get(i).AddText(offset,taille,nb_ligne,false);}
}
else{
int debactif=_tagActif.getDebut();
int finactif=_tagActif.getFin();
ListeTag tmp=new ListeTag();
  LogFile.println("/*************************************** ICI********************************/");
for (int i=0;i<size();i++) 
{ 
	if (_tagActif.getDebut()==get(i).getDebut() || get(i).getFin()==_tagActif.getFin())
	{
		if (offset==_tagActif.getFin() && get(i).getFin()!=offset)  get(i).AddText(offset,taille,nb_ligne,true); else
		if (offset==_tagActif.getDebut() && get(i).getDebut()!=offset) get(i).AddText(offset,taille,nb_ligne,true); else
		tmp.add(get(i));
	}
	else get(i).AddText(offset,taille,nb_ligne,true);
}
 LogFile.println("/*************************************** ICI********************************/"+tmp);

if (offset==_tagActif.getFin())
{
	boolean doit=false;
	for (int i=tmp.size()-1;i!=-1;i--) 
	{
		 LogFile.println("cas des balise interne cas 1: "+tmp.get(i)+"doit:"+doit);
		if (tmp.get(i)==_tagActif) doit=true;
		if (doit) tmp.get(i).AddText(offset,taille,nb_ligne,true);
	}

}
if (offset==_tagActif.getDebut())
{	
boolean doit =true;
for (int i=0;i<tmp.size();i++) 
{
	// LogFile.println(tmp.get(i));
 LogFile.println("cas des balise interne cas 2: "+tmp.get(i)+"doit:"+doit+"_tagActif"+_tagActif);
if (doit) 
{
 LogFile.println("on fait addText sur "+tmp.get(i));
	tmp.get(i).AddText(offset,taille,nb_ligne,true);

}
else tmp.get(i).AddText(offset,taille,nb_ligne,false);

if (tmp.get(i)==_tagActif) doit=false;
}
}

}

}
public boolean removeGroup(Tag tag)
{

if (tag==null) return false;
int offset=tag.getDebut();
int taille=tag.getFin()-tag.getDebut();
Vector tmp=new Vector(10,10);
for (int i=0;i<size();i++)
{
if (!get(i).IsDead(offset,taille)){
tmp.add(get(i));
}

}
_listeTag=tmp;
return true;
}
/**
 * enleve le tag "tag" de la liste <br>
 * renvoie vrai si le tag est dans la liste
 */
 
public boolean remove(Tag tag)
{
// LogFile.println("ListeTag::remove(tag)");

return _listeTag.remove(tag);
}
/**
 * prend en compte le fait que dans le document , on a enlever du text<br>
 * offset est l'endroit dans le document ou on a enlever le texte<br>
 * taille est la taille du texte enlever
 */
public void RemoveText(int offset,int taille,int nb_ligne)
{
// LogFile.println("ListeTag::RemoveText(offset,taille,nb_ligne)");

Vector tmp=new Vector (10,10);
for (int i=0;i<size();i++)
{
if (!get(i).IsDead(offset,taille)){

get(i).RemoveText(offset,taille,nb_ligne);
tmp.add(get(i));
}

}

_listeTag=tmp;
// LogFile.println("FIN ListeTag::RemoveText(offset,taille,nb_ligne)");
}
/**
 * met a jour un document graphique avec les tag
 */
/*public void UpDateDocument(TextAreaPane pane)
{
 LogFile.println("ListeTag::UpDateDocument(TextAreaPane)");
pane.Clean();
 LogFile.println("Sortie de Clean()");
for (int i=0;i<size();i++) 
{
if (get(i).IsDead()==false)
	pane.setAttributeSet(get(i).getBalise(),get(i).getDebut(),get(i).getFin());

pane.repaint();
}
 LogFile.println("Sortie de UpDateDocument");
}*/
/**
 * renvoie la taille de la liste
 */
public int size(){
	 LogFile.println("ListeTag::size()");

	return _listeTag.size();}


/**
 * renvoie le tag qui debute ou commence par debutorend
 */
public Tag getTagAtDebutOrEnd(int debutorend)
{
 LogFile.println("ListeTag::getTagAtDebutOrEnd(int)");

for (int i=0;i<size();i++) if (get(i).getTagAtDebutOrEnd(debutorend)) return get(i);
return null;
} 
public String toString()
{
String result=new String();
for (int i=0;i<size();i++) result=result.concat(get(i).getDebutStringBalise()+"\n");
return result;

}
public int getRealPosition(int caret)
{
int result=caret;
for (int i=0;i<size();i++) 
{
Tag t=get(i);
if (t.getDebut()<=result) result=result+t.getDebutStringBalise().length();
if (t.getFin()<=result) result=result+t.getFinStringBalise().length();

}
return result;
}

}