package style;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;
import javax.swing.border.*;
import myEvent.*;
import logique.*;
import tools.*;
public class EditStyleDialog extends JDialog implements BaliseChoiceListener,FontPanelListener,SemantiquePanelListener
{
protected StylePanel _stylepanel;
protected ChoiceBalisePanel _baliseChoice;
protected JSplitPane _split;
protected JScrollPane _scroll;
protected EnsembleStyle _ensemble_style;
protected String select;
protected JButton ok;
public EditStyleDialog(JFrame frame)
{

super(frame,"Edition des style",true);
getContentPane().setLayout(new BorderLayout());
 
_baliseChoice=new ChoiceBalisePanel();
try {_baliseChoice.addBaliseChoiceListener(this);} catch (Exception e){ LogFile.println(e);}

_stylepanel=new StylePanel();
_split=new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,
                 true,_baliseChoice,
                 _stylepanel
                 );

                 _split.setDividerLocation(.75);
//_scroll=new JScrollPane();
//_scroll.getViewport().add(_split);

_stylepanel.addFontPanelListener(this);
_stylepanel.addSemantiquePanelListener(this);
getContentPane().add(_split,BorderLayout.CENTER);
ok=new JButton("Close");
ok.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent e) {
    	EditStyleDialog.this.setVisible(false);
      }});
  getContentPane().add(ok,BorderLayout.SOUTH);    
pack();
}
public void BaliseChoiceChanged(BaliseChoiceEvent evt)
{
// LogFile.println(evt);
if (_ensemble_style!=null)
{
	logique.Style style=_ensemble_style.get(evt.getAttribute());
	select=new String(evt.getAttribute());
	
	_stylepanel.set(evt.getAttribute(),style);
	SemantiqueRule rule=style.getSemantiqueStyle();
	
	
	
}
}
public void FontChanged(FontPanelEvent evt)
{
if (select!=null) _ensemble_style.update(select,evt.getAttribute());
}
public void SemantiqueChanged(SemantiquePanelEvent evt)
{
if (select!=null) _ensemble_style.update(select,evt.getAttribute());
}
public void setEnsembleStyle(EnsembleStyle en)
{
_ensemble_style=en;
_baliseChoice.setData(en);
repaint();

}
public static void main(String [] args)
{
JFrame frame=new JFrame();
EditStyleDialog r=new EditStyleDialog(frame);
EnsembleStyle ens=new EnsembleStyle("test");
ens.AddStyle("toto",new logique.Style());
ens.AddStyle("titi",new logique.Style());
ens.AddStyle("tata",new logique.Style());
r.setEnsembleStyle(ens);
r.setVisible(true);
}
}