package xml;
import logique.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import org.xml.sax.*;
import org.xml.sax.ext.DeclHandler;
import org.apache.xerces.parsers.SAXParser;
import org.xml.sax.helpers.DefaultHandler;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.text.*;

/**
 * 1-06-03 <br>
 *
 * permet de sauver un texte xml vers du Html<br>
 * Copyright (C) 2003 Gros Pierre-Emmanuel<br>
 * 
 * gros@limsi.fr<br>
 * 
 * 
 *
 * This program is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU General Public License<br>
 * as published by the Free Software Foundation; either version 2<br>
 * of the License, or any later version.<br>
 *
 * This program is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the<br>
 * GNU General Public License for more details.<br>
 *
 * You should have received a copy of the GNU General Public License<br>
 * along with this program; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.<br>
 *
 * Cree pour gerer la gestion Html de java parfois imparfaite
 *  @author Gros Pierre Emmanuel
 *         <a href="mailto:gros@limsi.fr">gros@limsi.fr</a>
 * @version 9.0
 *
 */
public class SaveHTML 
{
	


/**
 * ecrit une balise dans un print writer sous forme de html
 * @param _write : le flux de sortie 
 * @param b: la balise
 */

public static void WriteBaliseHTML(PrintWriter _writer ,Balise b)
{
_writer.print("."+b.getName());
b.getStyle("default").getGraphicStyle().WriteStyleHTML(_writer);
//WriteStyleHTML(_writer,b.getAttribut());

}
/**
 * ecrit une liste de balise au format Html vers un flux de sortie
 * @param _writer : le flux de sortie
 * @param b : la liste des balises
 */
public static void WriteListeBaliseHTML(PrintWriter _writer,ListeBalise b)
{
for (int i=0;i<b.size();i++)
{
WriteBaliseHTML(_writer,(Balise)b.get(i));
}
}

/**
 * transforme une couleur au format html vers une couleur au format java
 * @param s une couleur du type #rrvvbb
 */
 


public static Color htmlcolor2javacolor(String s)
{
String strback=s.substring(1) ;
Color col=new Color(Integer.parseInt(strback,16));
return col;
}


}