package ihm;
import dialogtool.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
/**
 * 12-05-03 <br>
 *
 * TabbedPane permet a d ajouter les differents panneau dans l editeur<br>
 * Copyright (C) 2003 Gros Pierre-Emmanuel<br>
 * 
 * gros@limsi.fr<br>
 * 
 * 
 *
 * This program is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU General Public License<br>
 * as published by the Free Software Foundation; either version 2<br>
 * of the License, or any later version.<br>
 *
 * This program is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the<br>
 * GNU General Public License for more details.<br>
 *
 * You should have received a copy of the GNU General Public License<br>
 * along with this program; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.<br>
 *
 * Permet d ajouter des panneau
 *  @author Gros Pierre Emmanuel
 *         <a href="mailto:gros@limsi.fr">gros@limsi.fr</a>
 * @version 9.0
 *
 * 
 */
public class TabbedPane extends JTabbedPane
{
	ListeTagIhm listetagihm;
	WarningPane wpane;
	WarningPane wcpane;
	
	/**
	 * construit le tabbed pane
	 */
	public TabbedPane()
	{
	super(JTabbedPane.BOTTOM);
}
/**
 * Construit un TabbedPane avec l arbre Xml
 */
	public TabbedPane(ListeTagIhm l)
	{
	this();
	listetagihm=l;
	addTab("Xml Tree",l);
}
/**
 * Construit un TabbedPane avec un arbre Xml et une fenetre de resultat de compilation
 */
	public TabbedPane(ListeTagIhm l,WarningPane p)
	{
	this(l);
	wpane=p;
	addTab("Validation result",p);
}
/**
 * Construit un TabbedPane avec un arbre Xml , une fenetre de resultat de compilation et une fenetre d'apparition du Xml Compile
 */
public TabbedPane(ListeTagIhm l,WarningPane p,WarningPane pp)
	{
	this(l,p);
	wcpane=pp;
	addTab("Tagged document",pp);
}
/**
 * nettoie les panneau
 */
public void clean()
{
wcpane.setText("");
wpane.setText("");
}

}