package logique;
import java.util.*;
import java.io.*;
import javax.swing.text.SimpleAttributeSet;
import org.xml.sax.*;
import tools.*;
public class EnsembleStyle implements XmlSerialisable
{
protected String _styleName;
protected Hashtable _hash;
protected int nombre;
public EnsembleStyle(String styleName)
{_styleName=new String(styleName);
 _hash=new Hashtable();
 nombre=0;
}
public EnsembleStyle()
{_styleName=new String("default");
 _hash=new Hashtable();
 nombre=0;
}

public void AddStyle(String baliseName,Style style)
{
if (baliseName!=null && style!=null)
{
_hash.put(baliseName, new CoupleHash(baliseName,style,nombre++));
}}
public Style get(String baliseName)
{
 LogFile.println("EnsembleStyle::get()");
return ((CoupleHash) _hash.get(baliseName)).style;
}

public void update(String ss,SimpleAttributeSet sim)
{
Style s=((CoupleHash) _hash.get(ss)).style;
s.getGraphicStyle().setAttributes(sim);
}
public void update(String ss,SemantiqueRule sim)
{
Style s=((CoupleHash) _hash.get(ss)).style;
s.setSemantiqueStyle(sim);
}
public String getXMLName(){return "EnsembleStyle";}

public Vector getBaliseName()
{
Vector result=new Vector();
for (Enumeration e = _hash.elements() ; e.hasMoreElements() ;) {
        result.add( ((CoupleHash) e.nextElement()).baliseName);
     
}
return result;
}
public Object clone()
{
return clone(_styleName);
}
public void lectXML(Attributes attributes,Vector construct)
{
 LogFile.println("Ensemble de style::lectXML");
_styleName=attributes.getValue("name");
for (int i=0;i<construct.size();i++) {
       CoupleHash c=(CoupleHash) construct.get(i);
       // LogFile.println(c);
       _hash.put(c.baliseName, c);
    
}
 LogFile.println("fin Ensemble de style::lectXML");
}
public String getStyleName(){return _styleName;}
public  void WriteXML(PrintWriter out)
{
out.print("<EnsembleStyle name=\""+_styleName+"\">\n");
for (Enumeration e = _hash.elements() ; e.hasMoreElements() ;) {
       CoupleHash c=(CoupleHash) e.nextElement();
      c.WriteXML(out);
     
}
out.print("</EnsembleStyle>\n");
out.flush();
}
public Object clone(String str)
{
EnsembleStyle result=new EnsembleStyle(new String(str));
for (Enumeration e = _hash.elements() ; e.hasMoreElements() ;) {
	CoupleHash c=(CoupleHash)(((CoupleHash) e.nextElement()).clone());
        result._hash.put(c.baliseName, c);

}
return result;
}
}